;----------------------------------------------------------------------------------------
; IoEMacro Masm32 Library  
;
; Copyright 2007 Veria Kalantary - Ideas of East Company
; http://www.IdeasofEast.com; http://www.ioe.co.ir
;
;----------------------------------------------------------------------------------------

MAKELANGID MACRO p, s
  xor eax,eax
  mov eax,s
  shl eax,10
  xor ebx,ebx
  mov ebx,p
  or  eax,ebx
ENDM

abs  Macro   X
  local if, then, endif
  if: Cmp &X, 0 
      Jl  then
      Jmp endif
  then:
      Neg &X
  endif:
endm

StrM MACRO data:VARARG                    
    LOCAL Buff
.data
    Buff db data, 0h
.code
    exitm <addr Buff>
ENDM

enum MACRO enumname, initCount, parmlist:VARARG
 LOCAL count
 count = initCount
 enumname typedef byte
 FOR parm, <parmlist>
  parm = count
  count = count + 1
 ENDM
ENDM

L MACRO sText:REQ 
LOCAL str, chr, flag 
str TEXTEQU < > 
flag TEXTEQU <.> 
FORC chr, <&sText>  
   IFDIF flag, <\> 
      IFDIF str, < > 
         str CATSTR str, <,> 
      ENDIF 
   ENDIF 
   IFDIF flag, <\> 
      IFIDN <&chr>, <\> 
         flag CATSTR <\> 
      ELSE 
         str CATSTR str, <">, <&chr>, <"> 
      ENDIF 
   ELSE 
      flag CATSTR <X>         
      IFIDN <&chr>, <|> 
         str CATSTR str, <"!!"> 
         flag CATSTR < > 
      ENDIF        
      IFIDN <&chr>, <n> 
         str CATSTR str, <13,10> 
         flag CATSTR < > 
      ENDIF 
      IFIDN <&chr>, <0> 
         str CATSTR str, <0> 
         flag CATSTR < > 
      ENDIF        
      IFIDN <&flag>, <X>  
         str CATSTR str, <">, <&chr>, <"> 
      ENDIF 
      flag CATSTR < > 
   ENDIF 
ENDM 
EXITM str 
ENDM

m2m macro M1, M2
	push M2
	pop  M1
endm

StrToBstr$ MACRO lpStrBuff
	LOCAL bstr
	LOCAL dwBuffSize
	
	.data
		bstr BSTR 0
		dwBuffSize DWORD 0		
	.code	
	invoke lstrlen, lpStrBuff
	.if eax != 0
		shl eax, 1
		mov dwBuffSize, eax
		inc eax			
		invoke SysAllocStringByteLen, 0, eax
		mov bstr, eax
		Invoke MultiByteToWideChar, CP_ACP, 0, lpStrBuff, -1, bstr, dwBuffSize
		mov eax, bstr		
	.endif					
	EXITM <eax>
ENDM

BstrToStr$ MACRO bstr  
	LOCAL pszBuff
	LOCAL lenBuff
	
	.data
		pszBuff	DWORD 0
		lenBuff DWORD 0
	.code
	invoke WideCharToMultiByte, CP_ACP, 0, bstr, -1, pszBuff, 0, NULL, NULL
	.if eax > 0
		mov lenBuff, eax
		invoke GlobalAlloc, GPTR, eax				
		mov pszBuff, eax
		invoke WideCharToMultiByte, CP_ACP, 0, bstr, -1, pszBuff, lenBuff, NULL, NULL
		mov eax, pszBuff
	.endif
	EXITM <eax>			
ENDM

FreeBstr$ MACRO bstr
	invoke SysFreeString, bstr   		
	mov bstr, NULL
ENDM