;----------------------------------------------------------------------------------------
; Public Library  
;
; Copyright 2007 Veria Kalantary - Ideas of East Company
; http://www.IdeasofEast.com; http://www.ioe.co.ir
;
;----------------------------------------------------------------------------------------

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\advapi32.inc
include \masm32\include\oleaut32.inc
include \masm32\include\ole32.inc
include \masm32\include\oaidl.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\advapi32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib

include \masm32\macros\macros.asm

method0Proto      typedef proto :DWORD
method1Proto      typedef proto :DWORD
method2Proto      typedef proto :DWORD, :DWORD
method3Proto      typedef proto :DWORD, :DWORD, :DWORD
method4Proto      typedef proto :DWORD, :DWORD, :DWORD, :DWORD
method5Proto      typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method6Proto      typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method7Proto      typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method8Proto      typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method9Proto      typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method10Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method11Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD
method12Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD
method13Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD
method14Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD
method15Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
method16Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD
method17Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD
method18Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD
method19Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD
method20Proto     typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,    :DWORD, :DWORD, :DWORD, :DWORD

method0           typedef ptr method0Proto
method1           typedef ptr method1Proto
method2           typedef ptr method2Proto
method3           typedef ptr method3Proto
method4           typedef ptr method4Proto
method5           typedef ptr method5Proto
method6           typedef ptr method6Proto
method7           typedef ptr method7Proto
method8           typedef ptr method8Proto
method9           typedef ptr method9Proto
method10          typedef ptr method10Proto
method11          typedef ptr method11Proto
method12          typedef ptr method12Proto
method13          typedef ptr method13Proto
method14          typedef ptr method14Proto
method15          typedef ptr method15Proto
method16          typedef ptr method16Proto
method17          typedef ptr method17Proto
method18          typedef ptr method18Proto
method19          typedef ptr method19Proto
method20          typedef ptr method20Proto

memcpy proto :DWORD, :DWORD, :DWORD
memset proto :DWORD, :BYTE, :DWORD 
ShowErrorMessage proto :DWORD
CompareStructVar proto :DWORD, :DWORD, :DWORD
StrToBstr proto :DWORD
BstrToStr proto :BSTR 

.data?
    ErrorMessage        db          MAX_PATH dup(?)

.code

memcpy PROC ptrSrc:DWORD, ptrDest:DWORD, dwSize:DWORD     
	 mov  ecx, dwSize 
     mov  esi, ptrSrc       
     mov  edi, ptrDest
     cld
     rep  movsb
     ret
memcpy ENDP

memset PROC pMem:DWORD, dwVal:BYTE, dwSize:DWORD
    mov edi, pMem
    mov al, dwVal
    mov ecx, dwSize
    cld
    rep stosb 
    ret
memset ENDP

ShowErrorMessage PROC hDlg:DWORD
    invoke GetLastError	
	push eax	
	pop ebx
	invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, NULL, ebx, eax, OFFSET ErrorMessage, MAX_PATH, NULL
	invoke MessageBox, NULL, OFFSET ErrorMessage, NULL, MB_OK
    ret
ShowErrorMessage ENDP

CompareStructVar PROC pStructVarA: DWORD, pStructVarB: DWORD, dwSize: DWORD		
	mov esi, pStructVarA
	mov edi, pStructVarB
	mov ecx, dwSize
@@:
	mov eax, [esi]
	add esi, 4
	sub eax, [edi]
	jne @F
	add edi, 4
	sub ecx, 4	
	cmp ecx, 0
	jne @B	
	xor eax, eax
@@:
	ret
CompareStructVar endp

StrToBstr proc lpStrBuff: DWORD
	LOCAL bstr: DWORD
	LOCAL dwBuffSize: DWORD
	
	invoke lstrlen, lpStrBuff
	.if eax != 0
		shl eax, 1
		mov dwBuffSize, eax
		inc eax			
		invoke SysAllocStringByteLen, 0, eax
		mov bstr, eax
		Invoke MultiByteToWideChar, CP_ACP, 0, lpStrBuff, -1, bstr, dwBuffSize
		mov eax, bstr		
	.endif					
	ret
StrToBstr endp

BstrToStr proc bs: BSTR  
	LOCAL pszBuff: DWORD
	LOCAL lenBuff: DWORD
		
	invoke WideCharToMultiByte, CP_ACP, 0, bs, -1, pszBuff, 0, NULL, NULL
	.if eax > 0
		mov lenBuff, eax
		invoke GlobalAlloc, GPTR, eax				
		mov pszBuff, eax
		invoke WideCharToMultiByte, CP_ACP, 0, bs, -1, pszBuff, lenBuff, NULL, NULL
		mov eax, pszBuff
	.endif
	ret			
BstrToStr endp

FreeBstr proc bstr: BSTR
	invoke SysFreeString, bstr   		
	mov bstr, NULL
	ret
FreeBstr endp
